Unit xdspapi;
Interface
Uses Windows;

//        ()
//Const XDSP_BOARD_MEMORY        = 8192; //
//Const XDSP_BOARD_MEMORY        = 512;  //
//Const XDSP_BOARD_MEMORY        = 262144;  //
//Const XDSP_BOARD_MEMORY        = 1048576; //1M dwords
//Const XDSP_BOARD_MEMORY        = 3145728; //3M dwords
//Const XDSP_BOARD_MEMORY        = 4194304; //4M dwords
//Const XDSP_BOARD_MEMORY        = 8388608; //8M dwords
Const XDSP_BOARD_MEMORY        = 16777216; // 16M dwords

Const // ---    API 
  XDSP_STATUS_SUCCESS            = 0;
  XDSP_INVALID_DEVICE_HANDLE     = INVALID_HANDLE_VALUE;{FFFFFFFFh}

Const // ---    
  XDSP_DIN0                      = $00000001; //    0
  XDSP_DIN1                      = $00000002; //    1
  XDSP_DIN2                      = $00000004; //    2
  XDSP_DIN3                      = $00000008; //    3

  XDSP_DOUT0                     = $00000040; //   0
  XDSP_DOUT1                     = $00000080; //   1
  XDSP_DOUT2                     = $00000100; //   2
  XDSP_DOUT3                     = $00000200; //   3

  XDSP_NotProcessFlag_TO_DOUT0   = $00000800; // 1 -   1, 0 -    1  "  "
  XDSP_ProcessFlag_TO_DOUT1      = $00001000; // 1 -   3, 0 -    3  " "
  XDSP_ExtPuskEnable_TO_DOUT2    = $00002000; // 1 -   4, 0 -    4  ""
  XDSP_NotExtPuskEnable_TO_DOUT3 = $00004000; // 1 -   5, 0 -    5  " "
  XDSP_ExtPusk_EDGE              = $00004000; //      : 0 - , 1 - 

Type
  TDeviceHandle = THandle;
  PDWord        = ^DWord;
  PPointer      = ^Pointer;
  PPDmaMemoryBuffer=^PDmaMemoryBuffer;
  PDmaMemoryBuffer=^TDmaMemoryBuffer;
  TDmaMemoryBuffer=Array[1..XDSP_BOARD_MEMORY] Of Word;

// ---  ,   0..7,  handle  
Function XdspOpenDevice(bDeviceNumber:Byte; phInterruptEventHandle:PHandle; ppDmaBuffer1:PPDmaMemoryBuffer; ppDmaBuffer2:PPDmaMemoryBuffer; ppDmaBuffer3:PPDmaMemoryBuffer; ppDmaBuffer4:PPDmaMemoryBuffer;
                        pDmaBufferAddr1:PDWord; pDmaBufferAddr2:PDWord; pDmaBufferAddr3:PDWord; pDmaBufferAddr4:PDWord):TDeviceHandle; cdecl; external 'xdspapi.dll';
// ---  ,  handle  ,   
Function XdspCloseDevice(hDeviceHandle:TDeviceHandle):DWord; cdecl; external 'xdspapi.dll';

// ---      DMA 
Function XdspSetProcessLength(hDeviceHandle:TDeviceHandle; dwLength:DWORD):DWORD; cdecl; external 'xdspapi.dll';
// ---     
Function XdspSetSampleFrequencyDivider(hDeviceHandle:TDeviceHandle; dwDivider:DWORD):DWORD; cdecl; external 'xdspapi.dll';

// ---  RESET  -       DMA,   
Function XdspResetAll(hDeviceHandle:TDeviceHandle):DWORD; cdecl; external 'xdspapi.dll';

// ---    
Function XdspDACEnable(hDeviceHandle:TDeviceHandle):DWORD; cdecl; external 'xdspapi.dll';
// ---    
Function XdspDACDisable(hDeviceHandle:TDeviceHandle):DWORD; cdecl; external 'xdspapi.dll';

// ---       
Function XdspAddrCntrToADCDataEnable(hDeviceHandle:TDeviceHandle):DWORD; cdecl; external 'xdspapi.dll';
// ---       
Function XdspAddrCntrToADCDataDisable(hDeviceHandle:TDeviceHandle):DWORD; cdecl; external 'xdspapi.dll';

// ---    
Function XdspExternalStartEnable(hDeviceHandle:TDeviceHandle):DWORD; cdecl; external 'xdspapi.dll';
// ---    
Function XdspExternalStartDisable(hDeviceHandle:TDeviceHandle):DWORD; cdecl; external 'xdspapi.dll';

//  

Function XDSPSetDAC1Default(hDeviceHandle:TDeviceHandle; dwData:DWord):DWORD cdecl; external 'xdspapi.dll';
Function XDSPSetDAC2Default(hDeviceHandle:TDeviceHandle; dwData:DWord):DWORD cdecl; external 'xdspapi.dll';
Function XDSPSetPosEdgeExtStart(hDeviceHandle:TDeviceHandle):DWORD cdecl; external 'xdspapi.dll';
Function XDSPSetNegEdgeExtStart(hDeviceHandle:TDeviceHandle):DWORD cdecl; external 'xdspapi.dll';

Function XDSPHistBuffEnable(hDeviceHandle:TDeviceHandle):DWORD cdecl; external 'xdspapi.dll';
Function XDSPHistBuffDisable(hDeviceHandle:TDeviceHandle):DWORD cdecl; external 'xdspapi.dll';
Function XDSPDACCounterEnable(hDeviceHandle:TDeviceHandle):DWORD cdecl; external 'xdspapi.dll';
Function XDSPDACCounterDisable(hDeviceHandle:TDeviceHandle):DWORD cdecl; external 'xdspapi.dll';
Function XDSPDACtoADCEnable(hDeviceHandle:TDeviceHandle):DWORD cdecl; external 'xdspapi.dll';
Function XDSPDACtoADCDisable(hDeviceHandle:TDeviceHandle):DWORD cdecl; external 'xdspapi.dll';
Function XDSPWriteToADCDAC(hDeviceHandle:TDeviceHandle; data:Word; adc_flag:boolean; dac_flag:boolean):DWORD cdecl; external 'xdspapi.dll';
//New
Function XDSPReadDigInData(hDeviceHandle:TDeviceHandle; pdwData:PDWord):DWORD cdecl; external 'xdspapi.dll';
Function XDSPWriteDigOutData(hDeviceHandle:TDeviceHandle; dwData:DWord):DWORD cdecl; external 'xdspapi.dll';
Function XDSPDigExtStartEnable(hDeviceHandle:TDeviceHandle):DWORD cdecl; external 'xdspapi.dll';
Function XDSPDigExtStartDisable(hDeviceHandle:TDeviceHandle):DWORD cdecl; external 'xdspapi.dll';

//Write to DAC
Function XDspStartWrite(hDeviceHandle:TDeviceHandle; BufNumber:integer; RamNumber:integer; TimeOut:DWord):DWORD; cdecl; external 'xdspapi.dll';
//Read ADC
Function XDspStartRead(hDeviceHandle:TDeviceHandle; TimeOut:DWord; DMATrCB:DWord):DWORD; cdecl; external 'xdspapi.dll';


implementation
end.
